import { _ as __extends, a as __assign } from "./tslib.es6-f5d753a9.js";
import { j as jsxRuntimeExports } from "./jsx-runtime-77da1412.js";
import React, { createRef, Component } from "react";
import ReactDOM from "react-dom";
import CanvasWithContext from "./Canvas.js";
import "./index-43981852.js";
import "./TopBar.js";
import "./RectTools.js";
import "./AttributesTools.js";
import "./Input.js";
import "./EllipseTools.js";
import "./CircleTools.js";
import "./PathTools.js";
import "./TextTools.js";
import "./GenericTools.js";
import "./IconButton.js";
import "./Icon.js";
import "./DelDupTools.js";
import "./GroupTools.js";
import "./canvasContext-f53da4db.js";
import "./LeftBar.js";
import "./BottomBar.js";
import "./ColorButton.js";
const name = "@armco/svg-canvas";
const version = "0.1.1";
const type = "module";
const main = "index.js";
const module = "index.js";
const types = "./types/index.d.ts";
const scripts = {
  dev: "vite",
  start: "vite",
  build: "tsc && vite build",
  "build:publish": "vite --config vite-publish.config.ts build",
  generate: "plop",
  atom: "plop atom",
  molecule: "plop molecule",
  component: "plop component",
  page: "plop page",
  preview: "vite preview",
  test: "vitest",
  format: "prettier --write .",
  lint: "eslint .",
  "type-check": "tsc",
  "publish:local": "./publish-local.sh",
  "publish:sh": "./publish.sh",
  "publish:sh:minor": "./publish.sh minor"
};
const dependencies = {
  "@armco/svg-editor": "^1.0.0",
  "@reduxjs/toolkit": "^1.8.1",
  "@svgedit/svgcanvas": "^7.2.2",
  bootstrap: "^5.3.2",
  "color-string": "^1.9.1",
  react: "^17",
  "react-app-polyfill": "^3.0.0",
  "react-color": "^2.19.3",
  "react-dev-utils": "^12.0.1",
  "react-dom": "^17",
  "react-redux": "^8.0.1",
  "react-router-dom": "^6.13.0",
  svgedit: "^7.3.3"
};
const devDependencies = {
  "@rollup/plugin-typescript": "^11.1.5",
  "@testing-library/dom": "^9.2.0",
  "@testing-library/jest-dom": "^5.11.4",
  "@testing-library/react": "^14.0.0",
  "@testing-library/user-event": "^14.2.5",
  "@types/color-string": "^1.5.5",
  "@types/react": "^18.0.15",
  "@types/react-color": "^3.0.10",
  "@types/react-dom": "^18.0.6",
  "@types/testing-library__jest-dom": "^5.14.5",
  "@vitejs/plugin-react": "^4.0.0",
  eslint: "^8.0.0",
  "eslint-config-react-app": "^7.0.1",
  "eslint-plugin-prettier": "^4.2.1",
  jsdom: "^21.1.0",
  plop: "^3.1.2",
  prettier: "^2.7.1",
  "prettier-config-nick": "^1.0.2",
  sass: "^1.63.4",
  typescript: "^5.0.2",
  vite: "^4.0.0",
  vitest: "^0.30.1"
};
const eslintConfig = {
  "extends": [
    "react-app",
    "react-app/jest"
  ],
  plugins: [
    "prettier"
  ],
  rules: {
    "prettier/prettier": "error",
    "react/jsx-no-target-blank": "off"
  }
};
const prettier = "prettier-config-nick";
const repository = {
  type: "git",
  url: "git+https://github.com/ReStruct-Corporate-Advantage/.git"
};
const keywords = [
  "components",
  "atomic",
  "building-blocks",
  "foundation"
];
const peerDependencies = {
  react: "^17",
  "react-dom": "^17"
};
const files = [
  "*"
];
const license = "ISC";
const bugs = {
  url: "https://github.com/ReStruct-Corporate-Advantage/react-vite-rtk-template/issues"
};
const homepage = "https://github.com/ReStruct-Corporate-Advantage/react-vite-rtk-template#readme";
const PACKAGE = {
  name,
  version,
  type,
  main,
  module,
  types,
  scripts,
  dependencies,
  devDependencies,
  eslintConfig,
  prettier,
  repository,
  keywords,
  peerDependencies,
  files,
  license,
  bugs,
  homepage
};
const editor = "";
var VERSION = PACKAGE.version;
var MiniEditor = (
  /** @class */
  function(_super) {
    __extends(MiniEditor2, _super);
    function MiniEditor2(props) {
      var _this = this;
      var _a, _b, _c, _d, _e;
      _this = _super.call(this, props) || this;
      _this.svgContent = "";
      _this.svgUpdate = function(svgContent) {
        _this.logDebugData("svgUpdate", _this.config.saveHandler !== null);
        _this.svgContent = svgContent;
        if (_this.config.saveHandler !== null) {
          _this.config.saveHandler(_this.svgContent);
        }
      };
      _this.onClose = function() {
        _this.logDebugData("onClose", _this.config.onCloseHandler !== null);
        _this.containerRef.current && ReactDOM.unmountComponentAtNode(_this.containerRef.current);
        if (!!_this.config.onCloseHandler) {
          _this.config.onCloseHandler();
        }
      };
      _this.logDebugData = function(functionName, args) {
        var _a2;
        if (_this.config.debug) {
          console.info("%c%s", "color:green", _this.config.debugPrefix, functionName, args, (_a2 = new Error().stack) === null || _a2 === void 0 ? void 0 : _a2.split(/\n/)[2]);
        }
      };
      _this.containerRef = createRef();
      _this.svgContent = props.svgContent;
      _this.config = {
        debug: ((_a = props.config) === null || _a === void 0 ? void 0 : _a.debug) !== void 0 ? props.config.debug : true,
        i18n: ((_b = props.config) === null || _b === void 0 ? void 0 : _b.i18n) !== void 0 ? props.config.i18n : "en",
        saveHandler: ((_c = props.config) === null || _c === void 0 ? void 0 : _c.saveHandler) !== void 0 ? props.config.saveHandler : null,
        onCloseHandler: ((_d = props.config) === null || _d === void 0 ? void 0 : _d.onCloseHandler) !== void 0 ? props.config.onCloseHandler : null,
        debugPrefix: ((_e = props.config) === null || _e === void 0 ? void 0 : _e.debugPrefix) !== void 0 ? props.config.debugPrefix : "editor"
      };
      return _this;
    }
    MiniEditor2.prototype.componentDidUpdate = function() {
    };
    MiniEditor2.prototype.load = function(svgContent) {
      this.logDebugData("load", svgContent === null || svgContent === void 0 ? void 0 : svgContent.length);
      try {
        ReactDOM.render(React.createElement(CanvasWithContext, {
          svgContent,
          locale: this.config.i18n,
          svgUpdate: this.svgUpdate,
          onClose: this.onClose,
          log: this.logDebugData
        }, null), this.containerRef.current);
      } catch (err) {
        console.error("could not load the SVG content", err);
        throw err;
      }
    };
    MiniEditor2.prototype.info = function() {
      console.info("Editor version:", VERSION);
      var info = {
        version: VERSION,
        currentConfig: this.config,
        container: this.containerRef.current
      };
      return info;
    };
    MiniEditor2.prototype.getSvg = function() {
      this.logDebugData("getSvg");
      return this.svgContent;
    };
    MiniEditor2.prototype.configure = function(name2, value) {
      this.logDebugData("configure", { name: name2, value });
      if (typeof this.config[name2] === "undefined") {
        throw new Error("".concat(name2, " is not a valid configuration"));
      }
      this.config[name2] = value;
      return this.config;
    };
    MiniEditor2.prototype.render = function() {
      var props = {
        svgContent: this.props.svgContent,
        locale: this.config.i18n,
        svgUpdate: this.svgUpdate,
        onClose: this.onClose,
        log: this.logDebugData
      };
      return jsxRuntimeExports.jsx("div", { className: "ar-Editor", ref: this.containerRef, children: jsxRuntimeExports.jsx(CanvasWithContext, __assign({}, props)) });
    };
    return MiniEditor2;
  }(Component)
);
export {
  MiniEditor as default
};
