import { j as jsxRuntimeExports } from "./jsx-runtime-77da1412.js";
import React from "react";
import { P as PropTypes } from "./index-43981852.js";
import RectTools from "./RectTools.js";
import EllipseTools from "./EllipseTools.js";
import CircleTools from "./CircleTools.js";
import PathTools from "./PathTools.js";
import TextTools from "./TextTools.js";
import GenericTools from "./GenericTools.js";
import DelDupTools from "./DelDupTools.js";
import GroupTools from "./GroupTools.js";
import AttributesTools from "./AttributesTools.js";
import { c as canvasContext } from "./canvasContext-f53da4db.js";
import "./IconButton.js";
import "./Icon.js";
import "./tslib.es6-f5d753a9.js";
import "./Input.js";
const TopBar$1 = "";
var TopBar = function(_a) {
  var _b;
  var svgUpdate = _a.svgUpdate, onClose = _a.onClose;
  var canvasState = React.useContext(canvasContext)[0];
  var canvas = canvasState.canvas, selectedElement = canvasState.selectedElement, mode = canvasState.mode, updated = canvasState.updated;
  console.info(mode, selectedElement === null || selectedElement === void 0 ? void 0 : selectedElement.tagName);
  var handleChange = function(type, newVal) {
    var elem = selectedElement;
    switch (type) {
      case "font-family":
        canvasState.canvas.setFontFamily(newVal);
        break;
      case "font-size":
        canvasState.canvas.setFontSize(newVal);
        break;
      case "id":
        canvasState.canvas.clearSelection();
        elem.id = newVal;
        canvasState.canvas.addToSelection([elem], true);
        break;
      default:
        console.error("type (".concat(type, ") not supported"));
    }
  };
  var ElementTools;
  switch ((_b = canvasState.selectedElement) === null || _b === void 0 ? void 0 : _b.tagName) {
    case "rect":
      ElementTools = jsxRuntimeExports.jsx(RectTools, { canvas, canvasUpdated: updated, selectedElement, svgUpdate, onClose });
      break;
    case "circle":
      ElementTools = jsxRuntimeExports.jsx(CircleTools, { canvas, canvasUpdated: updated, selectedElement, svgUpdate, onClose });
      break;
    case "ellipse":
      ElementTools = jsxRuntimeExports.jsx(EllipseTools, { canvas, canvasUpdated: updated, selectedElement, svgUpdate, onClose });
      break;
    case "text":
      ElementTools = jsxRuntimeExports.jsx(TextTools, { selectedElement, handleChange });
      break;
    case "path":
      ElementTools = jsxRuntimeExports.jsx(PathTools, { canvas, canvasUpdated: updated, selectedElement, svgUpdate, onClose });
      break;
    case "g":
    case "image":
    case "line":
    case "polygon":
    case "polyline":
    case "textPath":
    default:
      ElementTools = selectedElement && jsxRuntimeExports.jsx(AttributesTools, { selectedElement, handleChange, attributes: {} });
  }
  return jsxRuntimeExports.jsxs("div", { className: "top-bar", children: [jsxRuntimeExports.jsx(GenericTools, { canvas, canvasUpdated: updated, selectedElement, svgUpdate, onClose }), jsxRuntimeExports.jsx(DelDupTools, { canvas }), jsxRuntimeExports.jsx(GroupTools, { canvas, multiselected: canvasState.multiselected, selectedElement }), ElementTools && ElementTools] });
};
TopBar.propTypes = {
  svgUpdate: PropTypes.func.isRequired,
  onClose: PropTypes.func.isRequired
};
export {
  TopBar as default
};
