import { a as __assign } from "./tslib.es6-f5d753a9.js";
import { j as jsxRuntimeExports } from "./jsx-runtime-77da1412.js";
import React from "react";
import { P as PropTypes } from "./index-43981852.js";
var updateCanvas = function(svgCanvas, cnvs, curConfig, center, newCtr) {
  if (newCtr === void 0) {
    newCtr = {};
  }
  var workarea = cnvs.parentNode;
  var _a = workarea.getBoundingClientRect(), w = _a.width, h = _a.height;
  var wOrig = w;
  var hOrig = h;
  var oldCtr = {
    x: workarea.scrollLeft + wOrig / 2,
    y: workarea.scrollTop + hOrig / 2
  };
  var multi = curConfig.canvas_expansion;
  var zoom = svgCanvas.getZoom();
  w = Math.max(wOrig, svgCanvas.contentW * zoom * multi);
  h = Math.max(hOrig, svgCanvas.contentH * zoom * multi);
  if (w === wOrig && h === hOrig) {
    workarea.style.overflow = "hidden";
  } else {
    workarea.style.overflow = "scroll";
  }
  var _b = cnvs.getBoundingClientRect(), cw = _b.width, ch = _b.height;
  var oldCanY = ch / 2;
  var oldCanX = cw / 2;
  cnvs.style.width = w;
  cnvs.style.height = h;
  var newCanY = h / 2;
  var newCanX = w / 2;
  var offset = svgCanvas.updateCanvas(w, h);
  var ratio = newCanX / oldCanX;
  var scrollX = w / 2 - wOrig / 2;
  var scrollY = h / 2 - hOrig / 2;
  if (!newCtr.x) {
    var oldDistX = oldCtr.x - oldCanX;
    var newX = newCanX + oldDistX * ratio;
    var oldDistY = oldCtr.y - oldCanY;
    var newY = newCanY + oldDistY * ratio;
    newCtr.x = newX;
    newCtr.y = newY;
  } else {
    newCtr.x += offset.x;
    newCtr.y += offset.y;
  }
  if (center) {
    if (svgCanvas.contentW > workarea.getBoundingClientRect().width) {
      workarea.scrollLeft = offset.x - 10;
      workarea.scrollTop = offset.y - 10;
    } else {
      workarea.scrollLeft = scrollX;
      workarea.scrollTop = scrollY;
    }
  } else {
    workarea.scrollLeft = newCtr.x - wOrig / 2;
    workarea.scrollTop = newCtr.y - hOrig / 2;
  }
};
var reducer = function(state, action) {
  var newMode;
  var canvas = state.canvas;
  switch (action.type) {
    case "init":
      return __assign(__assign({}, state), { canvas: action.canvas, svgcanvas: action.svgcanvas, config: action.config });
    case "mode":
      canvas.setMode(action.mode);
      return __assign(__assign({}, state), { mode: action.mode });
    case "selectedElement":
      newMode = (canvas === null || canvas === void 0 ? void 0 : canvas.getMode()) === "select" ? { mode: "select" } : {};
      return __assign(__assign(__assign({}, state), { selectedElement: action.selectedElement, multiselected: action.multiselected }), newMode);
    case "zoom":
      canvas.setZoom(action.zoom / 100);
      updateCanvas(canvas, state.svgcanvas, state.config, true);
      return __assign(__assign({}, state), { zoom: action.zoom });
    case "context":
      return __assign(__assign({}, state), { context: action.context, layerName: canvas.getCurrentDrawing().getCurrentLayerName() });
    case "color":
      canvas.setColor(action.colorType, action.color, false);
      return state;
    case "deleteSelectedElements":
      canvas.deleteSelectedElements();
      return state;
    case "setTextContent":
      canvas.setTextContent(action.text);
      return state;
    case "updated":
      newMode = (canvas === null || canvas === void 0 ? void 0 : canvas.getMode()) !== "textedit" ? { mode: "select" } : {};
      return __assign(__assign({}, state), { updated: action.updated });
    default:
      throw new Error("unknown action type: ".concat(action.type));
  }
};
var canvasInitialState = {
  mode: "select",
  selectedElement: null,
  multiselected: false,
  updated: false,
  zoom: 100,
  context: null,
  layerName: ""
};
var canvasContext = React.createContext(null);
var CanvasContextProvider = function(_a) {
  var children = _a.children;
  return jsxRuntimeExports.jsx(canvasContext.Provider, { value: React.useReducer(reducer, canvasInitialState), children });
};
CanvasContextProvider.propTypes = { children: PropTypes.element.isRequired };
export {
  CanvasContextProvider as C,
  canvasContext as c,
  updateCanvas as u
};
